#ifndef __fsys_h__
#define __fsys_h__

#include "stdlib/stddef.h"

typedef void FSYS_FILE;

#define SEEK_SET	0	/* Seek from beginning of file.  */
#define SEEK_CUR	1	/* Seek from current position.  */
#define SEEK_END	2	/* Seek from end of file.  */

extern FSYS_FILE* fsys_fopen(const char*, const char*);
extern int        fsys_fread(void*, size_t, size_t, FSYS_FILE*);
extern int        fsys_fclose(FSYS_FILE*);
extern int        fsys_fseek(FSYS_FILE*, long int, int);
extern long int   fsys_ftell(FSYS_FILE*);
extern int        fsys_ferror(FSYS_FILE*);
extern int        fsys_feof(FSYS_FILE*);
extern int        fsys_fwrite(const void*, size_t, size_t, FSYS_FILE*);

extern int        fsys_remove(const char*);

#endif
