#include "malloc.h"
#include "errno.h"
#include "string.h"
#include "stdint.h"

#define _VALLOC_PAGE_BOUNDRY 0

void* calloc(size_t num, size_t size) {
	unsigned char* tempOut = (unsigned char*)malloc(num * size);
	if(tempOut == NULL)
		return NULL;
	memset(tempOut, 0x00, (num * size));
	return (void*)tempOut;
}

void* memalign(size_t align, size_t size) {
	if((align == 0) || ((align & (align -1)) != 0)) {
		errno = EINVAL;
		return NULL;
	}
	void* tempOut = malloc(size);
	if(tempOut == NULL)
		return NULL;
	if(((uintptr_t)tempOut & (align - 1)) == 0)
		return tempOut;
	free(tempOut);

	return NULL;
}

void* valloc(size_t size) {

	return memalign(_VALLOC_PAGE_BOUNDRY, size);
}
