#include "string.h"
#include "stdint.h"
#include "malloc.h"

int strlen(const char * str)
{
    const char * s = str;
    for (; *s; ++s);
    return(s - str);

}

char * strcat(char *dest, const char *src)
{
    strcpy(dest + strlen(dest), src);
    return dest;
}

char* strcpy(char* outDest, const char* inSrc) {
	size_t i;
	if((outDest == NULL) || (inSrc == NULL))
		return NULL;

	for(i = 0; inSrc[i] != '\0'; i++)
		outDest[i] = inSrc[i];
	outDest[i] = '\0';
	return outDest;
}




char * strrchr(const char *p, int ch)
{
        char *save;

        for (save = NULL;; ++p) {
                if (*p == ch)
                        save = (char *)p;
                if (!*p)
                        return(save);
  }
        /* NOTREACHED */
}

char * strchr(const char *p, int ch)
{
        for (;; ++p) {
                if (*p == ch)
                        return((char *)p);
                if (!*p)
                        return((char *)NULL);
  }
        /* NOTREACHED */
}


int strcasecmp(const char *s1, const char *s2)
{
        const u_char *cm = charmap;
        const u_char *us1 = (const u_char *)s1;
        const u_char *us2 = (const u_char *)s2;

        while (cm[*us1] == cm[*us2++])
                if (*us1++ == '\0')
                        return (0);
        return (cm[*us1] - cm[*--us2]);
}

int strncasecmp(const char *s1, const char *s2, size_t n)
{
        if (n != 0) {
                const u_char *cm = charmap;
                const u_char *us1 = (const u_char *)s1;
                const u_char *us2 = (const u_char *)s2;

                do {
                        if (cm[*us1] != cm[*us2++])
                                return (cm[*us1] - cm[*--us2]);
                        if (*us1++ == '\0')
      break;
                } while (--n != 0);
  }
        return (0);
}


char* strncpy(char* outDest, const char* inSrc, size_t inLength) {
	size_t i;
	if((outDest == NULL) || (inSrc == NULL))
		return NULL;

	for(i = 0; (inSrc[i] != '\0') && (i < inLength); i++)
		outDest[i] = inSrc[i];
	outDest[i] = '\0';
	return outDest;
}

int strcmp(const char* inStr0, const char* inStr1 ) {
	uintptr_t i;
	if(inStr0 == NULL) {
		if(inStr1 == NULL)
			return 0;
		return -inStr1[0];
	}
	if(inStr1 == NULL)
		return (unsigned char)inStr0[0];

	for(i = 0; (inStr0[i] != '\0') || (inStr1[i] != '\0'); i++) {
		if(inStr0[i] != inStr1[i])
			return (inStr0[i] - inStr1[i]);
	}
	return 0;
}

int strncmp(const char* inStr0, const char* inStr1, size_t inLength ) {
    uintptr_t i;
	if(inStr0 == NULL) {
		if(inStr1 == NULL)
			return 0;
		return -inStr1[0];
	}
	if(inStr1 == NULL)
		return (unsigned char)inStr0[0];

	for(i = 0; (i < inLength) && ((inStr0[i] != '\0') || (inStr1[i] != '\0')); i++) {
		if(inStr0[i] != inStr1[i])
			return (inStr0[i] - inStr1[i]);
	}
	return 0;
}

char * strpbrk(const char *s1, const char *s2)
{
        const char *scanp;
        int c, sc;

        while ((c = *s1++) != 0) {
                for (scanp = s2; (sc = *scanp++) != 0;)
                        if (sc == c)
                                return ((char *)(s1 - 1));
        }
        return (NULL);
}


void* memcpy(void* outDest, const void* inSrc, size_t inLength) {
	size_t i;
	if((outDest == NULL) || (inSrc == NULL))
		return NULL;

	for(i = 0; i < inLength; i++)
		((uint8_t*)outDest)[i] = ((uint8_t*)inSrc)[i];

	return outDest;
}

void* memmove(void* outDest, const void* inSrc, size_t inLength) {
	size_t i;
	if((uintptr_t)outDest < (uintptr_t)inSrc)
		return memcpy(outDest, inSrc, inLength);
	if((uintptr_t)outDest >= ((uintptr_t)inSrc + inLength))
		return memcpy(outDest, inSrc, inLength);

	for(i = (inLength - 1); (i + 1) != 0; i--)
		((uint8_t*)outDest)[i] = ((uint8_t*)inSrc)[i];

	return outDest;
}

void* memset(void* outDest, int inValue, size_t inLength) {
	size_t i;
	if(outDest == NULL)
		return NULL;
	if((inValue >= 256) || (inValue < -128))
		return NULL;

	for(i = 0; i < inLength; i++)
		((uint8_t*)outDest)[i] = (uint8_t)inValue;

	return outDest;
}


char  *strdup(const char * s)
{
    char *d = (char *)(malloc (strlen (s) + 1));
    if (d == NULL)
        return NULL;
    strcpy (d,s);
    return d;
}
