#include "lib/stdlib/stdlib.h"
#include "lib/stdlib/string.h"
#include "lib/stdlib/malloc.h"
#include "lib/fsys.h"

#ifdef ALT_PATH_SEP
#define SEP ';'
#else
#define SEP ':'
#endif



char  *strdupnew(const char * s)
{
    char *d = (char *)(malloc (strlen (s) + 1));
    if (d == NULL)
        return NULL;
    strcpy (d,s);
    return d;
}


char *path_search(char *name, char *mode, char *path)
{
	FSYS_FILE *f;
	static char *buf;
	char *p, *n;
	int l;

	if (buf) free(buf); buf = 0;
	if (!path || !*path || *name == '/')
		return (buf = strdupnew(name));

	buf = malloc(strlen(path) + strlen(name) + 2);

	for (p = path; *p; p += l)
	{
		if (*p == SEP) p++;
		n = strchr(p, SEP);
		if (n) l = n - p;
		else l = strlen(p);
		strncpy(buf, p, l);
		buf[l] = '/';
		strcpy(buf+l+1, name);
		if ((f = fsys_fopen(buf, mode)))
		{
			fsys_fclose(f);
			return buf;
		}
	}
	return name;
}







