/*
 * nix.c
 *
 * System interface for *nix systems.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "time.h"
#include "unistd.h"
#include "errno.h"

#define DOTDIR ".gnuboy"

/*
#ifndef HAVE_USLEEP
static void my_usleep(unsigned int us)
{
	struct timeval tv;
	tv.tv_sec = 0;
	tv.tv_usec = us;
	select(0, NULL, NULL, NULL, &tv);
}
#endif
*/

void *sys_timer()
{
    unsigned int  ticks;

    ticks = OSTimeGet();
	return ldiv(ticks,64).quot;
}

int sys_elapsed(unsigned int * prev)
{
	unsigned int tv;
	int secs;
    unsigned int ticks;

    ticks = OSTimeGet();
	tv = ldiv(ticks,64).quot;
	secs = tv - *prev;
	*prev = tv;
	return secs;
}

void sys_sleep(int us)
{
	if (us <= 0) return;
	OSTimeDly(us);
}

void sys_checkdir(char *path, int wr)
{/*
	char *p;
	if (access(path, X_OK | (wr ? W_OK : 0)))
	{
		if (!access(path, F_OK))
			die("cannot access %s: %s\n", path, strerror(errno));
		p = strrchr(path, '/');
		if (!p) die("descended to root trying to create dirs\n");
		*p = 0;
		sys_checkdir(path, wr);
		*p = '/';
		if (mkdir(path, 0777))
			die("cannot create %s: %s\n", path, strerror(errno));
	} */
}

void sys_initpath()
{
	char *buf, *home = NULL;
	if (!home)
	{
		buf = ".";
		rc_setvar("rcpath", 1, &buf);
		rc_setvar("savedir", 1, &buf);
		return;
	}
	buf = malloc(strlen(home) + strlen(DOTDIR) + 8);
	sprintf(buf, "%s/" DOTDIR ":.", home);
	rc_setvar("rcpath", 1, "A:\\GAME");
	sprintf(buf, "%s/" DOTDIR "/saves" , home);
	rc_setvar("rcpath", 1, "A:\\GAME");
	rc_setvar("savedir", 1, "A:\\GAME");
	free(buf);
}

void sys_sanitize(char *s)
{
}




